﻿
''' <summary>
''' コマンド書式を定義する。
''' 
''' clsDataFormatPallApp は AppTwelite などで利用される以下のような形式となる。ペイロードバイト列は IDataPayload により規定する。
'''   4: [中継器のシリアル番号]
'''   1: [LQI値]
'''   2: [続番号]
'''   4: [送信元のシリアル番号]
'''   1: [送信元の論理ID]
'''   1: [0x80 固定 これ以外は AppTagでの識別子(未実装)]
'''   ---  以下のデータは IDataPayload により実装
'''   1: [PAL基板識別子]
'''   1: [センサデータ数]
'''     4: [センサーデータヘッダ]
'''     N: [センサーデータ]
'''     
''' </summary>
''' <remarks></remarks>
Public Class ClsDataFormatPalApp
    Implements ITweDataFormat

    Dim _bStored As Boolean
    Dim _dataPayload As ITweDataPayload

    Dim _uiRepeater As UInt32
    Dim _bLQI As Byte
    Dim _usDataSer As UInt16
    Dim _uiSrcAddr As UInt32
    Dim _bSrcAddr As Byte
    Dim _bPayFmt As Byte
    Dim _bPalPcb As Byte

    ''' <summary>
    ''' バイト列の解釈と ITweDataPayload の生成
    ''' </summary>
    ''' <param name="b"></param>
    ''' <returns></returns>
    Public Function parseByteArray(ByRef b() As Byte) As Boolean Implements ITweDataFormat.parseByteArray
        parseByteArray = False
        clearData()

        Dim i As UInteger = 0
        Try
            UiRepeater = get_BE_DWORD(b, i) : i += 4
            BLQI = b(i) : i += 1
            UsDataSer = get_BE_WORD(b, i) : i += 2
            UiSrcAddr = get_BE_DWORD(b, i) : i += 4
            BSrcAddr = b(i) : i += 1
            BPayFmt = b(i) : i += 1
            BPalPcb = b(i) : i += 1

 
            _dataPayload = genDataPayloadPAL(b.Skip(i).ToArray())
        Catch ex As Exception
            _dataPayload = Nothing
        End Try

        If (Not IsNothing(_dataPayload)) Then
            _bStored = True
            parseByteArray = True
        Else
            clearData()
        End If

    End Function

    Public Function toByteArray() As Byte() Implements ITweDataFormat.toByteArray
        Dim abyPayload As Byte()
        toByteArray = Nothing

        If _bStored And (Not IsNothing(_dataPayload)) Then
            abyPayload = _dataPayload.toByteArray()

            If Not IsNothing(abyPayload) Then
                'Dim abyOut As Byte()

                '' TO BE IMPLEMENTED
                ' ReDim abyOut(abyPayload.Length + 2 - 1)

                'abyOut(0) =
                'abyOut(1) = _dataPayload.getCmdId()

                ' Array.Copy(abyPayload, 0, abyOut, 2, abyPayload.Length) ' 残りをコピーする

                ' toByteArray = abyOut
            End If
        End If
    End Function

    Private Sub clearData()
        _bStored = False
        _dataPayload = Nothing
    End Sub

    Public Sub New()
        clearData()
    End Sub

    Public Sub New(ByRef b As Byte())
        parseByteArray(b)

        If Not _bStored Then
            Throw New Exception
        End If
    End Sub

    Public ReadOnly Property byFormatType As Byte Implements ITweDataFormat.byFormatType
        Get
            Return twePayloadFmtTypePal
        End Get
    End Property

    Public ReadOnly Property objPayload As ITweDataPayload Implements ITweDataFormat.objPayload
        Get
            Return _dataPayload
        End Get
    End Property

    Public Property UiRepeater As UInteger
        Get
            Return _uiRepeater
        End Get
        Set(value As UInteger)
            _uiRepeater = value
        End Set
    End Property

    Public Property BLQI As Byte
        Get
            Return _bLQI
        End Get
        Set(value As Byte)
            _bLQI = value
        End Set
    End Property

    Public Property UsDataSer As UShort
        Get
            Return _usDataSer
        End Get
        Set(value As UShort)
            _usDataSer = value
        End Set
    End Property

    Public Property UiSrcAddr As UInteger
        Get
            Return _uiSrcAddr
        End Get
        Set(value As UInteger)
            _uiSrcAddr = value
        End Set
    End Property

    Public Property BSrcAddr As Byte
        Get
            Return _bSrcAddr
        End Get
        Set(value As Byte)
            _bSrcAddr = value
        End Set
    End Property

    Public Property BPayFmt As Byte
        Get
            Return _bPayFmt
        End Get
        Set(value As Byte)
            _bPayFmt = value
        End Set
    End Property

    Public Property BPalPcb As Byte
        Get
            Return _bPalPcb
        End Get
        Set(value As Byte)
            _bPalPcb = value
        End Set
    End Property
End Class
