﻿
''' <summary>
''' コマンド書式を定義する。
''' 
''' clsDataFormatSimple は AppTwelite などで利用される以下のような形式となる。ペイロードバイト列は IDataPayload により規定する。
'''   [アドレスBYTE] [コマンド番号BYTE] [ペイロードバイト列]
''' 
''' </summary>
''' <remarks></remarks>
Public Class ClsDataFormatStdApp
    Implements ITweDataFormat

    Dim _bStored As Boolean
    Dim _dataPayload As ITweDataPayload
    Dim _byDstAddr As Byte
    Dim _byCmd As Byte

    Public Function parseByteArray(ByRef b() As Byte) As Boolean Implements ITweDataFormat.parseByteArray
        parseByteArray = False
        clearData()

        _byDstAddr = b(0)
        _byCmd = b(1)

        _dataPayload = genDataPayloadStdApp(b.Skip(2).ToArray(), _byCmd)

        If (Not IsNothing(_dataPayload)) Then
            _bStored = True
            parseByteArray = True
        Else
            clearData()
        End If

    End Function

    Public Function toByteArray() As Byte() Implements ITweDataFormat.toByteArray
        Dim abyPayload As Byte()
        toByteArray = Nothing

        If _bStored And (Not IsNothing(_dataPayload)) Then
            abyPayload = _dataPayload.toByteArray()

            If Not IsNothing(abyPayload) Then
                Dim abyOut As Byte()

                ReDim abyOut(abyPayload.Length + 2 - 1)

                abyOut(0) = _byDstAddr
                abyOut(1) = _dataPayload.getCmdId()

                Array.Copy(abyPayload, 0, abyOut, 2, abyPayload.Length) ' 残りをコピーする

                toByteArray = abyOut
            End If
        End If
    End Function

    Private Sub clearData()
        _bStored = False
        _dataPayload = Nothing
        _byDstAddr = 0
        _byCmd = 0
    End Sub

    Public Sub New()
        clearData()
    End Sub

    Public Sub New(ByVal dst As Byte, ByVal payload As ITweDataPayload)
        _dataPayload = payload

        If _dataPayload Is Nothing Then
            clearData()
            Throw New Exception
        Else
            _bStored = False
            _byCmd = payload.getCmdId()
            _byDstAddr = dst
            _bStored = True
        End If
    End Sub

    Public Sub New(ByRef b As Byte())
        parseByteArray(b)

        If Not _bStored Then
            Throw New Exception
        End If
    End Sub

    Public Property byDstAddr As Byte
        Get
            Return _byDstAddr
        End Get
        Set(ByVal value As Byte)
            _byDstAddr = value
        End Set
    End Property

    Public Property byCmd As Byte
        Get
            Return _byCmd
        End Get
        Set(ByVal value As Byte)
            _byCmd = value
        End Set
    End Property

    Public ReadOnly Property byFormatType As Byte Implements ITweDataFormat.byFormatType
        Get
            Return twePayloadFmtTypeSimple
        End Get
    End Property

    Public ReadOnly Property objPayload As ITweDataPayload Implements ITweDataFormat.objPayload
        Get
            Return _dataPayload
        End Get
    End Property
End Class
