﻿
''' <summary>
''' コマンド書式を定義する。
''' 
''' clsDataFormatSimple は単純な書式で、以下のような書式である。
'''   [アドレスBYTE] [コマンド番号BYTE] [ペイロードバイト列]
''' 
''' ※ 複雑なアドレスやオプションが格納されている書式拡張のため、インタフェース化している。
''' </summary>
''' <remarks></remarks>
Public Interface ITweDataFormat
    ''' <summary>
    ''' 書式バイト列を得る
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Function toByteArray() As Byte()

    ''' <summary>
    ''' バイト列から書式オブジェクトを生成する
    ''' </summary>
    ''' <param name="b"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Function parseByteArray(ByRef b As Byte()) As Boolean

    ''' <summary>
    ''' 書式オブジェクトのタイプを得る（ダウンキャストを行うために利用）
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    ReadOnly Property byFormatType() As Byte

    ''' <summary>
    ''' ペイロードオブジェクトを得る (Nothing の場合空)
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    ReadOnly Property objPayload() As ITweDataPayload
End Interface
